# geos::operation::relate::RelateNodeGraph Class Reference

Implements the simple graph of Nodes and geomgraph::EdgeEnd which is all that is required to determine topological relationships between Geometries. More...

`#include <RelateNodeGraph.h>`

List of all members.

## Public Member Functions

std::map< geom::Coordinate *, geomgraph::Node *, geom::CoordinateLessThen > & | getNodeMap ()
void | build (geomgraph::GeometryGraph *geomGraph)
void | computeIntersectionNodes (geomgraph::GeometryGraph *geomGraph, int argIndex)
void | copyNodesAndLabels (geomgraph::GeometryGraph *geomGraph, int argIndex)
void | insertEdgeEnds (std::vector< geomgraph::EdgeEnd * > *ee)

## Detailed Description

Implements the simple graph of Nodes and geomgraph::EdgeEnd which is all that is required to determine topological relationships between Geometries.

Also supports building a topological graph of a single Geometry, to allow verification of valid topology.

It is not necessary to create a fully linked PlanarGraph to determine relationships, since it is sufficient to know how the Geometries interact locally around the nodes. In fact, this is not even feasible, since it is not possible to compute exact intersection points, and hence the topology around those nodes cannot be computed robustly. The only Nodes that are created are for improper intersections; that is, nodes which occur at existing vertices of the Geometries. Proper intersections (e.g. ones which occur between the interior of line segments) have their topology determined implicitly, without creating a geomgraph::Node object to represent them.

The documentation for this class was generated from the following file:

- RelateNodeGraph.h